CREATE TABLE bm_resource_attribute (
    ID                         NUMBER(18, 0) ,
    PAR_RESOURCE_ID            NUMBER(18, 0)     NOT NULL,
    VARIABLE_NAME              VARCHAR2(512)     NOT NULL,
    COLUMN_NAME                VARCHAR2(120) ,
    DISPLAY_NAME               VARCHAR2(1020),
    DESCRIPTION                VARCHAR2(4000),
    FIELD_TYPE                 VARCHAR2(120) ,
    DATA_TYPE                  VARCHAR2(120) ,
    DATA_LENGTH                NUMBER(10, 0) ,
    DATA_PRECISION             NUMBER(10, 0) ,
    PRIMARY_KEY_FLAG           NUMBER(1, 0)  ,
    REQUIRED_FLAG              NUMBER(1, 0)  ,
    READONLY_FLAG              NUMBER(1, 0)  ,
    ALLOW_SEARCH_FLAG          NUMBER(1, 0)  ,
    ALLOW_SORT_FLAG            NUMBER(1, 0)  ,
    FORCE_ACTIVE_FLAG          NUMBER(1, 0)  ,
    DEST_RES_VARIABLE_NAME     VARCHAR2(512) ,
    SRC_ATTR_VARIABLE_NAME     VARCHAR2(512) ,
    DEST_ATTR_VARIABLE_NAME    VARCHAR2(512) ,
    CALC_EXPRESSION            VARCHAR2(4000),
    JOIN_CONSTRAINT_SPEC       VARCHAR2(2000),
    PREDEFAULT_VAL             VARCHAR2(2000),
    DATE_ADDED                 TIMESTAMP(6)      NOT NULL,
    DATE_MODIFIED              TIMESTAMP(6)      NOT NULL,
    DEPLOYMENT_STATUS          VARCHAR2(120) ,
    DISPLAY_DEST_ATTR          VARCHAR2(512) ,
    INTERNAL_FLAG              NUMBER(1, 0)  ,
    INTERNAL_SPEC              VARCHAR2(4000),
    LOGICAL_TYPE               VARCHAR2(120) ,
    LOOKUP_TYPE                VARCHAR2(120) ,
    CURRENCY_CODE              VARCHAR2(512) ,
    TRANSLATE_FLAG             NUMBER(1, 0)  ,
    CAN_INSERT_FLAG            NUMBER(1, 0)  ,
    CAN_UPDATE_FLAG            NUMBER(1, 0)  ,
    USER_KEY_FLAG              NUMBER(1, 0)  ,
    OBJECT_VERSION_NUMBER      NUMBER(9, 0)      NOT NULL,
    CREATED_BY                 VARCHAR2(256)     NOT NULL,
    CREATION_DATE              TIMESTAMP(6)      NOT NULL,
    LAST_UPDATED_BY            VARCHAR2(256)     NOT NULL,
    LAST_UPDATE_DATE           TIMESTAMP(6)      NOT NULL,
    LAST_UPDATE_LOGIN          VARCHAR2(128) ,
    SEED_DATA_SOURCE           VARCHAR2(2048),
    ORA_SEED_SET1              VARCHAR2(4)       NOT NULL,
    ORA_SEED_SET2              VARCHAR2(4)       NOT NULL,
    ID                         NUMBER(18, 0) ,
    PAR_RESOURCE_ID            NUMBER(18, 0)     NOT NULL,
    VARIABLE_NAME              VARCHAR2(512)     NOT NULL,
    COLUMN_NAME                VARCHAR2(120) ,
    DISPLAY_NAME               VARCHAR2(1020),
    DESCRIPTION                VARCHAR2(4000),
    FIELD_TYPE                 VARCHAR2(120) ,
    DATA_TYPE                  VARCHAR2(120) ,
    DATA_LENGTH                NUMBER(10, 0) ,
    DATA_PRECISION             NUMBER(10, 0) ,
    PRIMARY_KEY_FLAG           NUMBER(1, 0)  ,
    REQUIRED_FLAG              NUMBER(1, 0)  ,
    READONLY_FLAG              NUMBER(1, 0)  ,
    ALLOW_SEARCH_FLAG          NUMBER(1, 0)  ,
    ALLOW_SORT_FLAG            NUMBER(1, 0)  ,
    FORCE_ACTIVE_FLAG          NUMBER(1, 0)  ,
    DEST_RES_VARIABLE_NAME     VARCHAR2(512) ,
    SRC_ATTR_VARIABLE_NAME     VARCHAR2(512) ,
    DEST_ATTR_VARIABLE_NAME    VARCHAR2(512) ,
    CALC_EXPRESSION            VARCHAR2(4000),
    JOIN_CONSTRAINT_SPEC       VARCHAR2(2000),
    PREDEFAULT_VAL             VARCHAR2(2000),
    DATE_ADDED                 TIMESTAMP(6)      NOT NULL,
    DATE_MODIFIED              TIMESTAMP(6)      NOT NULL,
    DEPLOYMENT_STATUS          VARCHAR2(120) ,
    DISPLAY_DEST_ATTR          VARCHAR2(512) ,
    INTERNAL_FLAG              NUMBER(1, 0)  ,
    INTERNAL_SPEC              VARCHAR2(4000),
    LOGICAL_TYPE               VARCHAR2(120) ,
    LOOKUP_TYPE                VARCHAR2(120) ,
    CURRENCY_CODE              VARCHAR2(512) ,
    TRANSLATE_FLAG             NUMBER(1, 0)  ,
    CAN_INSERT_FLAG            NUMBER(1, 0)  ,
    CAN_UPDATE_FLAG            NUMBER(1, 0)  ,
    USER_KEY_FLAG              NUMBER(1, 0)  ,
    OBJECT_VERSION_NUMBER      NUMBER(9, 0)      NOT NULL,
    CREATED_BY                 VARCHAR2(256)     NOT NULL,
    CREATION_DATE              TIMESTAMP(6)      NOT NULL,
    LAST_UPDATED_BY            VARCHAR2(256)     NOT NULL,
    LAST_UPDATE_DATE           TIMESTAMP(6)      NOT NULL,
    LAST_UPDATE_LOGIN          VARCHAR2(128) ,
    SEED_DATA_SOURCE           VARCHAR2(2048),
    ORA_SEED_SET1              VARCHAR2(4)       NOT NULL,
    ORA_SEED_SET2              VARCHAR2(4)       NOT NULL,
    CONSTRAINT pk_bm_resource_attribute PRIMARY KEY (ID, ID)
);
